/************************
 * new2.cpp
 * dynamick alokace pamti
 * s vyuitm vjimky
 *  neda se, ono to odswapuje a vjimka stejn nenastane - pamti je dost
 ************************/

#include <iostream>
#include <new>
#include <cstdlib>

using namespace std;

const int hodne = 100000000L; // 8 nul

class velka {
	int velke[hodne];
	char *ident;
public:
	velka(int delka) {
		ident = new char[delka];
	} // velka()
	~velka() {
		delete [] ident;
	} // ~velka()
};


int main() {
 int delka_alok_retezce = 1000000;
 velka *moc_velkych_trid[hodne];
 cout << "hodne=" << hodne;
 try {
	  for (int i = 0; i < hodne; i++) {
		  moc_velkych_trid[i] = new velka(delka_alok_retezce);
	  }
 }
 catch (bad_alloc ba) {
	 cout << "tak tahle alokace se nepodarila" << endl;
	 exit(-1);
 }
 cout << "tak se to podarilo" << endl;
 for (int i = 0; i < hodne; i++) {
	 delete [] moc_velkych_trid[i];
 }
 return 0;
} // int main()
