/**************************************************
 * soubor zsb-hluboka.cpp
 * tda s dynamicky alokovanmi lenskmi daty
 * oproti souboru zsb-melka.cpp
 * vytvoen a vyuit koprovac konstruktor
 **************************************************/

#include <iostream>
#include <new>
#include <exception>
#include <stdexcept>

using namespace std;

class zasobnik {
private:
	int velikost;
	int *vrchol, *pzasobnik;
public:
	zasobnik(int i = 100) : velikost(i) {
		vrchol = pzasobnik = new int[velikost];
		cout << "zasobnik vytvoren" << endl;
	}
	zasobnik(const zasobnik& zas) {
        velikost = zas.velikost;
        vrchol = pzasobnik = new int[velikost];
        cout << "zasobnik vytvoren" << endl;
        int pocet = *zas.vrchol - *zas.pzasobnik;
//memcpy(pzasobnik,zas.pzasobnik,pocet*sizeof(int));
		for (int i = 0; i < pocet; i++) {
			pzasobnik[i] = zas.pzasobnik[i];
		}
		vrchol = pzasobnik + pocet;
		cout << "data zkopirovana" << endl;
	}
	~zasobnik(void) {
		cout << "rusim alokovane pole" << endl;
		delete[] pzasobnik;
		cout << "zasobnik zrusen" << endl;
	}
	void push(int i) {
		if ( (vrchol-pzasobnik) < velikost) {
			*vrchol = i; vrchol++;}
	}
	int pop(void) {
		if (--vrchol >= pzasobnik)
			return *vrchol;
		else
			throw new 
				out_of_range("neni prostor na zasobniku");
	}
}; // class zasobnik

int main() {
	zasobnik zas1(50);
	int i;
	for (i = 0; i < 50; i++)
		zas1.push(i);
	cout << "zasobnik 1:" << endl;
	for(i=0; i < 5; i++)
		cout << zas1.pop() << '\t';
	cout << endl;

	zasobnik zas2 = zas1; 
	// pouit explicitn koprovac konstruktor
	cout << endl << "zasobnik 2:" << endl;
	for(i = 0; i < 5; i++)
		cout << zas2.pop() << '\t';

	zas2.push(1234);
	cout << endl << endl 
		 << "zasobnik 1 vrchol:" << zas1.pop() << endl 
		 << "zasobnik 2 vrchol:" << zas2.pop() << endl;
    return 0;
} // int main()